import java.util.Random;
import java.util.ArrayList;

public class Slika
{
    protected Tacka t; // teziste slike
    
    public Slika(){
        t = new Tacka();
    }
    
    public Slika(double x, double y){
        t = new Tacka(x, y);
    }
    
    public double povrsina() {return 0;}
    public double obim() {return 0;}
    
    // prepisuje se metod toString iz klase Object
    public String toString(){
        return "nalazi se u " + t;
    }
    
    public Tacka teziste(){return t;}
    
    public static void test(int n){
        
        Random rg = new Random();
        ArrayList<Slika> slike = new ArrayList<>();
        // pravimo slike
        for(int i = 0; i < n; i++){
            if(rg.nextBoolean()) { // bacam novcic
                slike.add(new Krug(i, i, 1 + 10*rg.nextDouble()));
            } else {
                slike.add(new Pravougaonik(i, i, 1 + 10*rg.nextDouble(), 1 + 10*rg.nextDouble()));
            }
        }
        // trazimo sliku sa max povrsinom
        // double makspov = -1;
        // Slika najveca = null;
        // for(Slika s : slike){
            // double tp = s.povrsina();
            // if(tp > makspov){
                // makspov = tp; 
                // najveca = s;
            // }
        // }
        // trazimo pravougaonik sa max povrsinom
        double makspov = -1;
        Slika najveca = null;
        for(Slika s : slike){
            if(s instanceof Pravougaonik){
                double tp = s.povrsina();
                if(tp > makspov){
                    makspov = tp; 
                    najveca = s;
                }
            }
        }
        // ispis najvece
        if(najveca != null) {
            System.out.println("Slika sa najvecom povrsinom je");
            System.out.println(najveca);
        } else {
            System.out.println("Nema slike koja zadovoljava trazeni kriterijum!");
        }
    }
    
}
